searchData={"items":[{"type":"module","title":"Strucord","doc":"","ref":"Strucord.html"},{"type":"extras","title":"Strucord","doc":"# Strucord\n\nNote!: This is fork of https://github.com/QuinnWilton/strucord. It has been forked to add nested structs support.\n\nAllows for easy interop with Erlang records.\n\nBy using it in a module, it autogenerates a struct for the given record, along with functions for converting between the struct and the record.\n\nI primarily use this for calling Gleam code from Elixir.","ref":"readme.html"},{"type":"extras","title":"Installation - Strucord","doc":"```elixir\ndef deps do\n  [\n    {:nested_strucord, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Example - Strucord","doc":"Using the module will define three functions, `with_record/2`, `from_record/1`, and `to_record/1`.\n\n`with_record/2` takes a struct as argument, and a function that takes a record as argument. It will convert the struct to a record, pass it to the function, and then convert the result of the function back to a struct.\n\n`from_record/1` takes a record as argument, and returns a struct.\n\n`to_record/1` takes a struct as argument, and returns a record.\n\n`overrides` it is an optional argument takes keyword list of options. For example: it could of array of nested structs or just a nested struct\n\n- tags: {:list, Tag}\n- tag: Tag\n\n```elixir\ndefmodule Emulator do\n  use Strucord,\n    name: :emulator,\n    from: \"gen/src/chip8@emulator_Emulator.hrl\",\n    overrides: []\n\n  def init() do\n    from_record(:chip8@emulator.init())\n  end\n\n  def reset(%Emulator{} = emulator) do\n    with_record(emulator, fn record ->\n      :chip8@emulator.reset(record)\n    end)\n  end\n\n  def load_rom(%Emulator{} = emulator, rom) when is_binary(rom) do\n    with_record(emulator, fn record ->\n      :chip8@emulator.load_rom(record, rom)\n    end)\n  end\nend\n```","ref":"readme.html#example"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}